#ifndef MONSTER_H
#define MONSTER_H

#include "shapes.h"
#include "main.h"

#include "mbed.h"
#include "N5110.h"

void joy_button_isr();

class Monster {
    
        public:
        
            Monster();
            void monster_main(N5110 &lcd, DigitalIn &button_A, DigitalIn &button_B, DigitalIn &button_C, DigitalIn &button_D,
            DigitalOut led1, DigitalOut led2, DigitalOut led3);
            void monster_main3(N5110 &lcd, DigitalIn &button_A, DigitalIn &button_B, DigitalIn &button_C, DigitalIn &button_D,
            DigitalOut led1, DigitalOut led2, DigitalOut led3);
            
        private:
            
            void drawbackground1(N5110 &lcd);
            void drawbackground2(N5110 &lcd);
            void drawlifes(N5110 &lcd, DigitalOut led1, DigitalOut led2, DigitalOut led3);
            void drawscores(N5110 &lcd);
            
            void draw_blackmonsters1(N5110 &lcd);
            void draw_blackmonsters2(N5110 &lcd);
            void draw_blackmonsters3(N5110 &lcd);
            void draw_jewels(N5110 &lcd);
            void draw_bullets(N5110 &lcd, DigitalIn &button_A);
            
            void draw_monster(N5110 &lcd, DigitalIn &button_A, DigitalIn &button_B, DigitalIn &button_C, DigitalIn &button_D);
            void draw_monster_level3(N5110 &lcd);
            
            void loss_life(N5110 &lcd);
            void game_over(N5110 &lcd, DigitalIn &button_A);
            
            void pause(N5110 &lcd, DigitalIn &button_A, DigitalIn &button_B);
            
            int monster_x1, monster_y1, turn1;
            int monster_x2, monster_y2, turn2;
            int monster_x3, monster_y3, turn3;
            
            int monster_x0, monster_y0;
            
            //开启宝石
            int jewels_on[7];
            int jewels_x[7];
            int jewels_y[7];
            
            void monster_main1(N5110 &lcd, DigitalIn &button_A, DigitalIn &button_B, DigitalIn &button_C, DigitalIn &button_D,
            DigitalOut led1, DigitalOut led2, DigitalOut led3);
            void monster_main2(N5110 &lcd, DigitalIn &button_A, DigitalIn &button_B, DigitalIn &button_C, DigitalIn &button_D,
            DigitalOut led1, DigitalOut led2, DigitalOut led3);
            
            //开启隐藏的第三关
            void continueFight(N5110 &lcd, DigitalIn &button_A, DigitalIn &button_B, DigitalIn &button_C, DigitalIn &button_D,
            DigitalOut led1, DigitalOut led2, DigitalOut led3);
};


#endif